
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Saved_listsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const saved_lists = await db.saved_lists.create(
            {
                id: data.id || undefined,
        
        list_name: data.list_name
        ||
        null
            ,
            
        list_type: data.list_type
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await saved_lists.setAccount( data.account || null, {
            transaction,
        });
        
        await saved_lists.setOwner( data.owner || null, {
            transaction,
        });
        

        

        

        return saved_lists;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const saved_listsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                list_name: item.list_name
            ||
            null
            ,
            
                list_type: item.list_type
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const saved_lists = await db.saved_lists.bulkCreate(saved_listsData, { transaction });

        // For each item created, replace relation files
        

        return saved_lists;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const saved_lists = await db.saved_lists.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.list_name !== undefined) updatePayload.list_name = data.list_name;
        
        
        if (data.list_type !== undefined) updatePayload.list_type = data.list_type;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await saved_lists.update(updatePayload, {transaction});

        
        
        if (data.account !== undefined) {
            await saved_lists.setAccount(
              
              data.account,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await saved_lists.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        

        return saved_lists;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const saved_lists = await db.saved_lists.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of saved_lists) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of saved_lists) {
                await record.destroy({transaction});
            }
        });


        return saved_lists;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const saved_lists = await db.saved_lists.findByPk(id, options);

        await saved_lists.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await saved_lists.destroy({
            transaction
        });

        return saved_lists;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const saved_lists = await db.saved_lists.findOne(
            { where },
            { transaction },
        );

        if (!saved_lists) {
            return saved_lists;
        }

        const output = saved_lists.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.saved_list_items_saved_list = await saved_lists.getSaved_list_items_saved_list({
            transaction
        });
        
        
        
        output.account = await saved_lists.getAccount({
            transaction
        });
        
        
        output.owner = await saved_lists.getOwner({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.accounts,
        as: 'account',
        
        where: filter.account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.list_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'saved_lists',
                        'list_name',
                        filter.list_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'saved_lists',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.list_type) {
                where = {
                    ...where,
                list_type: filter.list_type,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.saved_lists.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'saved_lists',
                        'list_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.saved_lists.findAll({
            attributes: [ 'id', 'list_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['list_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.list_name,
        }));
    }

    
};

